from sqlalchemy.exc import IntegrityError

from models.member import Member

from utils.database import DatabaseManager

def create_new_member(new_member: Member):
    try:
        with DatabaseManager.get_session() as session:
            session.add(new_member)
            session.commit()
    except IntegrityError as e:
        print(e)
        session.rollback()
